'*************************************************************************
'Contents of this file are (C)Copyright 2009 by Circuit Check Inc.  Any use of
'the contents of this file without an explicit license from Circuit Check Inc
'is THEFT.  Copyright violators will be prosecuted.
'
'        File : INIFile.vb
'        Type : Module
'    Language : Visual Basic
'    Revision : 1.0
'      Author : JE
'        Date : 050506
' Description : This routine is used to Read Information Stored In .ini Files
'    Revision : 1.01
'      Author : M. van Meeteren
'        Date : 121508
' Description : Added functions for writing back to the INI file
'    Revision : 1.02
'      Author : REG
'        Date : 112611
' Description : Modifications to correct the operation of WriteINIFile functions.
'               (original version would falsely error after approx 32K writes)
'
'*************************************************************************
Module IniFile

  Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
     (ByVal lpSectionName As String, ByVal lpKeyName As String, _
      ByVal lpDefault As String, ByVal lpReturnedString As String, _
      ByVal nSize As Integer, ByVal lpFileName As String) As UInt32

  Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
     (ByVal lpSectionName As Integer, ByVal lpKeyName As String, _
      ByVal lpDefault As String, ByVal lpReturnedString As String, _
      ByVal nSize As Integer, ByVal lpFileName As String) As UInt32

  Public Declare Unicode Function GetPrivateProfileStringW Lib "kernel32" Alias "GetPrivateProfileStringW" _
     (ByVal lpSectionName As String, ByVal lpKeyName As String, _
      ByVal lpDefault As String, ByVal lpReturnedString As String, _
      ByVal nSize As Integer, ByVal lpFileName As String) As UInt32

  Public Function ReadINIFile(ByVal Section As String, ByVal Key As String, ByVal DefaultValue As String, ByVal FileName As String, Optional ByVal Unicode As Boolean = False, Optional ByVal ForceOut As Boolean = False) As String
    Dim Buffer As New String(" "c, 4096)
    Dim found As UInt32

    If Unicode Then
      found = GetPrivateProfileStringW(Section, Key, String.Empty, Buffer, 4096, FileName)
    Else
      found = GetPrivateProfileString(Section, Key, String.Empty, Buffer, 4096, FileName)
    End If
    If found > 0 Then
      ReadINIFile = Buffer.Substring(0, CInt(found))
    Else
      ReadINIFile = DefaultValue
    End If
  End Function

End Module
