﻿Friend Class SCPIError

  Public Shared Function SCPIErrorToString(ByVal ErrorNumber As Integer) As String
    Dim ErrorString As String

    Select Case ErrorNumber
      Case -100
        ErrorString = "Command error"
      Case -101
        ErrorString = "Invalid character"
      Case -102
        ErrorString = "Syntax error"
      Case -103
        ErrorString = "Invalid separator"
      Case -104
        ErrorString = "Data type error"
      Case -105
        ErrorString = "GET not allowed"
      Case -108
        ErrorString = "Parameter not allowed"
      Case -109
        ErrorString = "Missing parameter"
      Case -110
        ErrorString = "Command header error"
      Case -111
        ErrorString = "Header separator error"
      Case -112
        ErrorString = "Program mnemonic too long"
      Case -113
        ErrorString = "Undefined header"
      Case -114
        ErrorString = "Header suffix out of range"
      Case -115
        ErrorString = "Unexpected number of parameters"
      Case -120
        ErrorString = "Numeric data error"
      Case -121
        ErrorString = "Invalid character in number"
      Case -123
        ErrorString = "Exponent too large"
      Case -124
        ErrorString = "Too many digits"
      Case -128
        ErrorString = "Numeric data not allowed"
      Case -130
        ErrorString = "Suffix error"
      Case -131
        ErrorString = "Invalid suffix"
      Case -134
        ErrorString = "Suffix too long"
      Case -138
        ErrorString = "Suffix not allowed"
      Case -140
        ErrorString = "Character data error"
      Case -141
        ErrorString = "Invalid character data"
      Case -144
        ErrorString = "Character data too long"
      Case -148
        ErrorString = "Character data not allowed"
      Case -150
        ErrorString = "String data error"
      Case -151
        ErrorString = "Invalid string data"
      Case -158
        ErrorString = "String data not allowed"
      Case -160
        ErrorString = "Block data error"
      Case -161
        ErrorString = "Invalid block data"
      Case -168
        ErrorString = "Block data not allowed"
      Case -170
        ErrorString = "Expression error"
      Case -171
        ErrorString = "Invalid expression"
      Case -178
        ErrorString = "Expression data not allowed"
      Case -180
        ErrorString = "Macro error"
      Case -181
        ErrorString = "Invalid outside macro definition"
      Case -183
        ErrorString = "Invalid inside macro definition"
      Case -184
        ErrorString = "Macro parameter error"
      Case -200
        ErrorString = "Execution error"
      Case -201
        ErrorString = "Invalid while in local"
      Case -202
        ErrorString = "Settings lost due to rtl"
      Case -203
        ErrorString = "Command protected TK024"
      Case -210
        ErrorString = "Trigger error"
      Case -211
        ErrorString = "Trigger ignored"
      Case -212
        ErrorString = "Arm ignored"
      Case -213
        ErrorString = "Init ignored"
      Case -214
        ErrorString = "Trigger deadlock"
      Case -215
        ErrorString = "Arm deadlock"
      Case -220
        ErrorString = "Parameter error"
      Case -221
        ErrorString = "Settings conflict"
      Case -222
        ErrorString = "Data out of range"
      Case -223
        ErrorString = "Too much data"
      Case -224
        ErrorString = "Illegal parameter value"
      Case -225
        ErrorString = "Out of memory"
      Case -226
        ErrorString = "Lists not same length"
      Case -230
        ErrorString = "Data corrupt or stale"
      Case -231
        ErrorString = "Data questionable"
      Case -232
        ErrorString = "Invalid format PH073"
      Case -233
        ErrorString = "Invalid version PH073"
      Case -240
        ErrorString = "Hardware error"
      Case -241
        ErrorString = "Hardware missing"
      Case -250
        ErrorString = "Mass storage error"
      Case -251
        ErrorString = "Missing mass storage"
      Case -252
        ErrorString = "Missing media"
      Case -253
        ErrorString = "Corrupt media"
      Case -254
        ErrorString = "Media full"
      Case -255
        ErrorString = "Directory full"
      Case -256
        ErrorString = "File name not found"
      Case -257
        ErrorString = "File name error"
      Case -258
        ErrorString = "Media protected"
      Case -260
        ErrorString = "Expression error"
      Case -261
        ErrorString = "Math error in expression"
      Case -270
        ErrorString = "Macro error"
      Case -271
        ErrorString = "Macro syntax error"
      Case -272
        ErrorString = "Macro execution error"
      Case -273
        ErrorString = "Illegal macro label"
      Case -274
        ErrorString = "Macro parameter error"
      Case -275
        ErrorString = "Macro definition too long"
      Case -276
        ErrorString = "Macro recursion error"
      Case -277
        ErrorString = "Macro redefinition not allowed"
      Case -278
        ErrorString = "Macro header not found"
      Case -280
        ErrorString = "Program error"
      Case -281
        ErrorString = "Cannot create program"
      Case -282
        ErrorString = "Illegal program name"
      Case -283
        ErrorString = "Illegal variable name"
      Case -284
        ErrorString = "Program currently running"
      Case -285
        ErrorString = "Program syntax error"
      Case -286
        ErrorString = "Program runtime error"
      Case -290
        ErrorString = "Memory use error"
      Case -291
        ErrorString = "Out of memory HP079"
      Case -292
        ErrorString = "Referenced name does not exist HP079"
      Case -293
        ErrorString = "Referenced name already exists HP079"
      Case -294
        ErrorString = "Incompatible type PH076"
      Case -300
        ErrorString = "Device-specific error"
      Case -310
        ErrorString = "System error"
      Case -311
        ErrorString = "Memory error HP098"
      Case -312
        ErrorString = "PUD memory lost"
      Case -313
        ErrorString = "Calibration memory lost"
      Case -314
        ErrorString = "Save/recall memory lost"
      Case -315
        ErrorString = "Configuration memory lost"
      Case -320
        ErrorString = "Storage fault HP098"
      Case -321
        ErrorString = "Out of memory HP098+Edit"
      Case -330
        ErrorString = "Self-test failed"
      Case -340
        ErrorString = "Calibration failed TK051"
      Case -350
        ErrorString = "Queue overflow"
      Case -360
        ErrorString = "Communication error TK014"
      Case -361
        ErrorString = "Parity error in program message TK014"
      Case -362
        ErrorString = "Framing error in program message TK014"
      Case -363
        ErrorString = "Input buffer overrun HP079"
      Case -365
        ErrorString = "Time out error"
      Case -400
        ErrorString = "Query error"
      Case -410
        ErrorString = "Query INTERRUPTED"
      Case -420
        ErrorString = "Query UNTERMINATED"
      Case -430
        ErrorString = "Query DEADLOCKED"
      Case -440
        ErrorString = "Query UNTERMINATED after indefinite response"
      Case -999
        ErrorString = "Internal exception"
      Case Else
        ErrorString = "Error not defined"
    End Select
    Return ErrorString
  End Function

End Class
