'*************************************************************************
'Contents of this file are (C)Copyright 2009 by Circuit Check Inc.  Any use of
'the contents of this file without an explicit license from Circuit Check Inc
'is THEFT.  Copyright violators will be prosecuted.
'
'        File : dioclass.vb
'        Type : Class
'    Language : Visual Basic
'    Revision : 1.0
'      Author : M. van Meeteren
'        Date : 022009
' Description : Base class for DIO equipment
'
'*************************************************************************

' Rules to remember for DIO in CCITest:
'
' 1) all entries in the INI file are 0 based as it relates to ports.  In other
'    words, output=a,b,c and iomaskn=0xFF, a,b,c,n are all 0 based as it relates 
'    to the port number
' 2) in the iomask directional flag, as well as internally for direction, a set bit
'    indicates an INPUT!
' 3) the addresses on the Agilent gear tend to mimic the equipment.  On NI gear, 
'    all the ports are 1 based when it relates to the address.  In other words, a 
'    device with a base address of 1000 will have port 0 at 1001, port 1 at 1002, etc.
'    Some devices, like the USB series Agilent gear will have inputs at 1101-1104 
'    and outputs at 1201-1204.  
Imports System.Threading

Friend MustInherit Class DIO_Class
  Inherits Device_Class

  Enum DIOType
    dioVirtual
    dioKeithley3750
  End Enum

  Friend Overrides Function DeviceType() As Device_Type
    Return Device_Type.dtDIO
  End Function

  Friend Overridable Function ReadByte(ByVal Channel As Integer, ByRef Value As Byte) As Boolean
    Value = &HFF
    DeviceError("DIO Channel Number Not Found")
    Return False
  End Function

  Friend Overrides Sub CloseDevice()
  End Sub

End Class

