'*************************************************************************
'Contents of this file are (C)Copyright 2009 by Circuit Check Inc.  Any use of
'the contents of this file without an explicit license from Circuit Check Inc
'is THEFT.  Copyright violators will be prosecuted.
'
'        File : dmmclass.vb
'        Type : Class
'    Language : Visual Basic
'    Revision : 1.0
'      Author : M. van Meeteren
'        Date : 022009
' Description : Base class for DMM equipment
'
'*************************************************************************

Friend MustInherit Class DMM_Class
  Inherits Device_Class

  Friend InputChannels As Integer = 1
  Friend DMMName As String = "DMM"
  Private MuxDMMName As String = "DMM"

  Friend Sub SetDMMName(ByVal DMMType As String, ByVal IDString As String)
    DMMName = "DMM " & DMMType
    MuxDMMName = DMMName
    If IDString <> String.Empty Then
      DMMName = DMMName & ": " & IDString
    End If
  End Sub

  Friend Enum DMMType
    dmmVirtual
    dmmKeithley3706A
  End Enum

  Friend Overrides Function DeviceType() As Device_Type
    Return Device_Type.dtDMM
  End Function

  Friend Overridable Function DMM_Type() As DMMType
    Return DMMType.dmmVirtual
  End Function

  Friend Overrides Sub CloseDevice()
    InittedOK = False
  End Sub

  ' exposes protected myaddress to muxes
  Friend Function BaseChannel() As Integer
    Return MyAddress
  End Function

  Friend Overrides Function TextChannelList() As String()
    Dim ReturnStrings() As String = {"Not initialized!"}

    If Not InittedOK Then Return ReturnStrings
    If (InputChannels = 1) Then
      ReturnStrings(0) = MyAddress.ToString & " " & DMMName
    Else
      ReturnStrings(0) = (MyAddress + 1).ToString & " - " & (MyAddress + InputChannels).ToString & " " & DMMName
    End If
    Return ReturnStrings
  End Function

End Class

