﻿Public Class frmMain


  Dim WithEvents DMM As DMM_Keithley3706A
  Dim WithEvents DIO As DIO_Keithley3750

  Private Sub Status(S As String) Handles DMM.DeviceStatusEvent,
                                          DIO.DeviceStatusEvent
    txtStatus.AppendText(Now.ToString("HH:mm:ss.fff ") & S & vbCrLf)
  End Sub

  Dim BaseChannel As Integer = 0

  Private Sub btnInit_Click(sender As Object, e As EventArgs) Handles btnInit.Click
    Dim strPath As String = System.IO.Path.GetDirectoryName( _
        System.Reflection.Assembly.GetExecutingAssembly.Location)
    Dim INIFileName As String

    INIFileName = strPath + "\ccitestapi.ini"

    btnClose.PerformClick()
    Status("Initializing DMM...")
    DMM = New DMM_Keithley3706A(1, INIFileName)
    If Not DMM.InittedOK Then
      Status("Error: " & DMM.Equip_Error)
    Else
      Status("OK")
      BaseChannel = DMM.BaseChannel

      Status("Initializing DIO...")
      DIO = New DIO_Keithley3750(1, INIFileName, DMM)
      If Not DIO.InittedOK Then
        Status("Error: " & DIO.Equip_Error)
        Exit Sub
      Else
        Status("OK, Channels: ")
        Dim Channels() As String = DIO.TextChannelList
        For Each Channel As String In Channels
          Status(Channel)
        Next
        UcDIORead1.Init(3001 + BaseChannel)
        UcDIORead2.Init(3002 + BaseChannel)
        UcDIORead3.Init(3003 + BaseChannel)
        UcDIORead4.Init(3004 + BaseChannel)
      End If
    End If
  End Sub

  Private Sub btnClose_Click(sender As Object, e As EventArgs) Handles btnClose.Click
    If DMM IsNot Nothing Then
      Status("Closing DMM...")
      DIO = Nothing
      DMM.CloseDevice()
      Status("Closed")
      DMM = Nothing
    End If
  End Sub

  Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
    btnClose.PerformClick()
  End Sub

  Private Sub DIOTimer_Tick(sender As Object, e As EventArgs) Handles DIOTimer.Tick
    If DIO IsNot Nothing Then
      Dim ReadValue As Byte

      If DIO.ReadByte(BaseChannel + 3001, ReadValue) Then _
        UcDIORead1.SetPortValue(ReadValue)
      If DIO.ReadByte(BaseChannel + 3002, ReadValue) Then _
        UcDIORead2.SetPortValue(ReadValue)
      If DIO.ReadByte(BaseChannel + 3003, ReadValue) Then _
        UcDIORead3.SetPortValue(ReadValue)
      If DIO.ReadByte(BaseChannel + 3004, ReadValue) Then _
        UcDIORead4.SetPortValue(ReadValue)
    End If
  End Sub

End Class
