﻿'*************************************************************************
'Contents of this file are (C)Copyright 2012 by Circuit Check Inc.  Any use of
'the contents of this file without an explicit license from Circuit Check Inc
'is THEFT.  Copyright violators will be prosecuted.
'
'        File : ucDIOControl.vb
'        Type : User Control Class
'    Language : Visual Basic
'    Revision : 1.0
'      Author : M. van Meeteren
'        Date : 092512
' Description : User Control for an 8 bit DIO channel
'
'*************************************************************************

Imports System.Windows.Forms

Public Class ucDIORead
  Public Address As Integer = 0

  Public Event OutputStateChanged(ByVal Address As Integer, ByVal Bit As Integer, ByVal State As Boolean)

  Private SuspendEvents As Boolean = False

  Public Sub New()
    ' This call is required by the Windows Form Designer.
    InitializeComponent()
  End Sub

  Public Sub Init(ChannelNumber As Integer)
    Address = ChannelNumber
    DIOChannelGroup.Text = ChannelNumber.ToString
  End Sub

  Public Sub SetPortValue(ByVal Value As Byte)
    Dim Bit As Integer
    Dim State As Boolean
    Dim Color As System.Drawing.Color

    SuspendEvents = True
    Try
      For Bit = 0 To 7
        State = ((Value And (1 << Bit)) > 0)
        If State Then
          Color = Drawing.Color.Red
        Else
          Color = Drawing.Color.Silver
        End If
        Select Case Bit
          Case 0
            LED0.BackColor = Color
          Case 1
            LED1.BackColor = Color
          Case 2
            LED2.BackColor = Color
          Case 3
            LED3.BackColor = Color
          Case 4
            LED4.BackColor = Color
          Case 5
            LED5.BackColor = Color
          Case 6
            LED6.BackColor = Color
          Case 7
            LED7.BackColor = Color
        End Select
      Next
    Finally
      SuspendEvents = False
    End Try
  End Sub

End Class
